Package org.eclipse.help.search

## Interface ISearchEngine

All Known Subinterfaces:
  `ISearchEngine2`

    public interface ISearchEngine

A search engine that is a participant in the help search. All engines selected by the user to run are executed as background jobs using the same search expression. Engine is expected to accept the expression and the scope object. The results should be passed to the result collector object, and the search progress should be tracked by the progress monitor.

Search engines that have API access to the search server can provide a list of individual search results. Search engines for which only the URL is known are expected to return one search result containing a URL that is sufficient to open a web browser and see the search results there.

Search engine must be cancelable.

This interface is intended to be implemented by clients.

Since:
  3.1

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `run​(String query, ISearchScope scope, ISearchEngineResultCollector collector, IProgressMonitor monitor)`

### Method Detail

#### run

    void run​(String query,
             ISearchScope scope,
             ISearchEngineResultCollector collector,
             IProgressMonitor monitor)
      throws CoreException

Parameters:
  `query` - the search expression
  `scope` - the engine-specific scope object that is used to narrow the search or `null` if the default scope is assumed.
  `collector` - the search result collector handles results as they arrive
  `monitor` - progress monitor to track the search progress
Throws:
  `CoreException` - when there are problems in the engine